Summary:	API for Run-time Code Generation
Summary(pl.UTF-8):	API do generowania kodu w czasie działania
Name:		dyninst
Version:	10.1.0
Release:	1
License:	LGPL v2.1+
Group:		Libraries
# http://www.dyninst.org/downloads/dyninst-9.x
#Source0Download: https://github.com/dyninst/dyninst/releases
Source0:	https://github.com/dyninst/dyninst/archive/v%{version}/%{name}-%{version}.tar.gz
# Source0-md5:	3711fca820ceb8e76d5b026964c5029d
Patch0:		%{name}-libname.patch
Patch1:		%{name}-x32.patch
URL:		http://www.dyninst.org/dyninst
# libiberty
BuildRequires:	binutils-devel
BuildRequires:	boost-devel >= 1.47
BuildRequires:	cmake >= 2.6.4
BuildRequires:	elfutils-devel
BuildRequires:	flex
BuildRequires:	libdwarf-devel >= 0.20130126
BuildRequires:	libstdc++-devel >= 6:4.7
BuildRequires:	libxml2-devel >= 2
BuildRequires:	sed >= 4.0
BuildRequires:	texlive-format-pdflatex
Requires:	libdwarf >= 0.20130126
ExclusiveArch:	%{ix86} %{x8664} x32 aarch64 ppc ppc64 aarch64
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Dyninst is an Application Program Interface (API) to permit the
insertion of code into a running program. The API also permits
changing or removing subroutine calls from the application program.
Run-time code changes are useful to support a variety of applications
including debugging, performance monitoring, and to support composing
applications out of existing packages. The goal of this API is to
provide a machine independent interface to permit the creation of
tools and applications that use run-time code patching.

%description -l pl.UTF-8
Dyninst to API (interfejs programowy) pozwalający na wstawianie kodu
do działającego programu. API pozwala także na zmianę lub usuwanie
wywołań funkcji z programu aplikacji. Zmiany kodu w czasie działania
są przydatne w wielu zastosowaniach, w tym diagnostyce, monitorowaniu
wydajności oraz wsparciu składania aplikacji z istniejących pakietów.
Celem tego API jest zapewnienie niezależnego od maszyny interfejsu
pozwalającego na tworzenie narzędzi i aplikacji wykorzystujących
modyfikowanie kodu w czasie działania.

%package devel
Summary:	Header files for dyninst libraries
Summary(pl.UTF-8):	Pliki nagłówkowe bibliotek dyninst
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}
Requires:	libstdc++-devel >= 6:4.7

%description devel
Header files for dyninst libraries.

%description devel -l pl.UTF-8
Pliki nagłówkowe bibliotek dyninst.

%package static
Summary:	Static dyninst libraries
Summary(pl.UTF-8):	Statyczne biblioteki dyninst
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}

%description static
Static dyninst libraries.

%description static -l pl.UTF-8
Statyczne biblioteki dyninst.

%package doc
Summary:	Documentation for dyninst libraries
Summary(pl.UTF-8):	Dokumentacja do bibliotek dyninst
Group:		Documentation

%description doc
Documentation for dyninst libraries.

%description doc -l pl.UTF-8
Dokumentacja do bibliotek dyninst.

%prep
%setup -q
%patch0 -p1
%patch1 -p1

%build
%cmake . \
	-DINSTALL_CMAKE_DIR:PATH=%{_libdir}/cmake/Dyninst \
	-DINSTALL_DOC_DIR:PATH=%{_docdir}/dyninst \
	-DINSTALL_INCLUDE_DIR:PATH=%{_includedir}/dyninst \
	-DINSTALL_LIB_DIR:PATH=%{_libdir} \

%{__make}

%install
rm -rf $RPM_BUILD_ROOT

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun	-p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc COPYRIGHT CHANGELOG.md README.md
%attr(755,root,root) %{_bindir}/codeCoverage
%attr(755,root,root) %{_bindir}/parseThat
%attr(755,root,root) %{_libdir}/libdynC_API.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libdynC_API.so.10.1
%attr(755,root,root) %{_libdir}/libdynDwarf.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libdynDwarf.so.10.1
%attr(755,root,root) %{_libdir}/libdynElf.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libdynElf.so.10.1
%attr(755,root,root) %{_libdir}/libdyncommon.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libdyncommon.so.10.1
%attr(755,root,root) %{_libdir}/libdyninstAPI.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libdyninstAPI.so.10.1
%attr(755,root,root) %{_libdir}/libdyninstAPI_RT.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libdyninstAPI_RT.so.10.1
%attr(755,root,root) %{_libdir}/libinstructionAPI.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libinstructionAPI.so.10.1
%attr(755,root,root) %{_libdir}/libparseAPI.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libparseAPI.so.10.1
%attr(755,root,root) %{_libdir}/libpatchAPI.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libpatchAPI.so.10.1
%attr(755,root,root) %{_libdir}/libpcontrol.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libpcontrol.so.10.1
%attr(755,root,root) %{_libdir}/libstackwalk.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libstackwalk.so.10.1
%attr(755,root,root) %{_libdir}/libsymLite.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libsymLite.so.10.1
%attr(755,root,root) %{_libdir}/libsymtabAPI.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libsymtabAPI.so.10.1

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libdynC_API.so
%attr(755,root,root) %{_libdir}/libdynDwarf.so
%attr(755,root,root) %{_libdir}/libdynElf.so
%attr(755,root,root) %{_libdir}/libdyncommon.so
%attr(755,root,root) %{_libdir}/libdyninstAPI.so
%attr(755,root,root) %{_libdir}/libdyninstAPI_RT.so
%attr(755,root,root) %{_libdir}/libInst.so
%attr(755,root,root) %{_libdir}/libinstructionAPI.so
%attr(755,root,root) %{_libdir}/libparseAPI.so
%attr(755,root,root) %{_libdir}/libpatchAPI.so
%attr(755,root,root) %{_libdir}/libpcontrol.so
%attr(755,root,root) %{_libdir}/libstackwalk.so
%attr(755,root,root) %{_libdir}/libsymLite.so
%attr(755,root,root) %{_libdir}/libsymtabAPI.so
%{_includedir}/dyninst
%{_libdir}/cmake/Dyninst

%files static
%defattr(644,root,root,755)
%{_libdir}/libdyninstAPI_RT.a

%files doc
%defattr(644,root,root,755)
%{_docdir}/dyninst
%changelog
* Fri Aug 30 2019 TLD Linux <feedback@tld-linux.org>
- For complete changelog see: http://git.tld-linux.org/?p=packages/dyninst.git;a=log;h=master

* Wed Aug 28 2019 Marcin Krol <hawk@tld-linux.org> e356d51
- dropped cfg_to_dot (its from examples subdir)
- dropped unstrip and its non-binary *.db files

* Wed Aug 28 2019 Marcin Krol <hawk@tld-linux.org> 676d1ad
- updated to 10.1.0

* Mon Apr 22 2019 Jan Rękorajski <baggins@pld-linux.org> 1f0ad28
- fix building with boost 1.69+
- rel 2

* Sun Nov 26 2017 Jakub Bogusz <qboosh@pld-linux.org> ece5262
- updated to 9.3.2

* Mon Apr 10 2017 Jakub Bogusz <qboosh@pld-linux.org> 770436b
- updated to 9.3.1
- updated libname patch
- added types patch (fixes unsigned long vs Offset/Address type mismatches)

* Sun Apr 09 2017 Jan Rękorajski <baggins@pld-linux.org> 995b957
- rebuild with boost 1.63.0
- release 2 (by relup.sh)

* Mon Aug 01 2016 Jakub Bogusz <qboosh@pld-linux.org> 91c3c39
- updated to 9.2.0
- updated libname patch

* Mon May 16 2016 Elan Ruusamäe <glen@delfi.ee> ef7c3a6
- icu-57.1 rebuild
- release 2 (by relup.sh)

* Tue Apr 05 2016 Jakub Bogusz <qboosh@pld-linux.org> b42727c
- updated to 9.1.0
- removed obsolete build-symlite patch

* Sat Nov 14 2015 Jan Rękorajski <baggins@pld-linux.org> 0094d0d
- release 2 (by relup.sh)

* Sun Oct 25 2015 Jakub Bogusz <qboosh@pld-linux.org> c22bc6d
- added x32 patch, now builds on x32

* Sun Oct 25 2015 Jakub Bogusz <qboosh@pld-linux.org> 4fe92e2
- updated to 9.0.3 (note: new sonames)
- updated libname patch (adapted to cmake buildsystem)
- removed obsolete link patch
- added build-symlite patch (build symLite library even it other libs use symtabAPI library)

* Sat Jul 13 2013 Jakub Bogusz <qboosh@pld-linux.org> 6638e92
- new
- libname patch renames too common library name: libcommon to libdyncommon
- link patch fixed interlibrary linking

